{
  Full Windows-like .ini-file services. Version 1.1
  Copyright (C) V Kulimov, 1994 year.
  Portions Copyright   "".
  All right reserved.

  Whats new:
    楤
     GetPrivateProfileString(... , IniData: PIniFile);
     SetPrivateProfileString(..., IniData: PIniFile);
     GetPrivateProfileInt(... , IniData: PIniFile);
     SetPrivateProfileInt(... , IniData: PIniFile);
     GetPrivateProfileBoolean(... , IniData: PIniFile);
     SetPrivateProfileBoolean(... , IniData: PIniFile);

   Procedure KillPrivateProfile(Mode: TSaveMode; IniData: PIniFile);
   Procedure SavePrivateProfile(PName: PathStr; IniData: PIniFile);

    ࠡ   㪠⥫ Profile,   ᢮ IniData.
   .. ⥯    ᮡ  ࠡ뢠 ⢮
   .ini-䠩.
}

{$V-}

Unit
   IniServ;

Interface

Uses
  IniFile, Tools;

Type
  TSaveMode = ( psNone, psSave, psDefault );
  {   ० ࠭ .ini-䠩. ᯮ  맮 KillProfile,
    KillPrivateProfile }
  TBooleanNotion = (bnNumeric, bnRus, bnYesNo, bnBoolean, bnSwitch);
  {   SetProfileBoolean.  ᨬ  祭 ६
    Mode  .ini-䠩   ᠭ ᫥騬 ࠧ
    ͻ
                    Mean    
        Type     Ķ
                     
    Ķ
     bnNumeric     1    0  
                           
     bnRus            
                           
     bnYesNo      Yes   No 
                           
     bnBoolean   True False
                           
     bnSwitch     On   Off 
    ͼ
    }

Const
  Profile: PIniFile = Nil;

Procedure SaveProfile(PName: String);
Procedure LoadProfile(PName: String);
{
  樠 ६ Profile  뢠     䠩
    PName.
}
Procedure NewProfile(PName: String; HeadMessage: PNoSortedStringCollection);
{
  ᯮ, ᫨  ᮧ  ini.file c .
}

Procedure NewProfileDefault(PName: String);

Function  GetProfile(PName: String): PIniFile;
Procedure KillProfile(Mode: TSaveMode);

Procedure KillPrivateProfile(Mode: TSaveMode; IniData: PIniFile);
Procedure SavePrivateProfile(PName: String; IniData: PIniFile);

Function  GetProfileObj(Appl, Key:String): PKeyObj;
{   ᥪ [Appl],   ப
   key=value. 頥 ' PKeyObj  Nil ᫨  襫.
}

Function  GetProfileString(Appl, Key, Default:String): String;
{ 頥 祭 ᮮ⢥饥 key  ᥪ樨 Appl,
  १ 騥 ஡  ᫨  ਩.
  ᫨  室  `;'  祭,  ⠢ । 室
  ⢮ "祪  ⮩"  , ⮡ ணࠬ  
    ਩.
}

Procedure SetProfileString(Appl, Key, Eval: String);
{ 뢠  ᥪ Appl 祭   Key, 㪠
   Eval. ᫨    ᥪ樨,  ᮧ.
}

Function  GetProfileBoolean(Appl, Key:String; Default:Boolean): Boolean;
{
  祭 㭪樨  ᨬ  祭  ini.file
  ͻ
  TRUE  1     Yes  On   True  
  Ķ
  FALSE 0    No   Off  False 
  ͼ
  Function case-insensietive.
}

Procedure SetProfileBoolean(Appl, Key: String; Mean: Boolean; Mode: TBooleanNotion);
{
  ࠭ 㫥᪮ 祭  ini.file  , 㪠 ६ Mode:
  bnNumeric mean   0   or 1
  bnYesNo          Yes  / No
  bnLat            True / False
  bnRus               / 
  bnSwicth         On   / Off
}

Function  GetProfileInt(Appl, Key:String; Default:LongInt): LongInt;
Procedure SetProfileInt(Appl, Key: String; Mean: LongInt);
{ ᭮,  ?.. }

Function GetPrivateProfileString(Appl, Key, Default: String; IniData: PIniFile): String;
Procedure SetPrivateProfileString(Appl, Key, Eval: String; IniData: PIniFile);
Function GetPrivateProfileInt(Appl, Key:String; Default:LongInt; IniData: PIniFile): LongInt;
Procedure SetPrivateProfileInt(Appl, Key: String; Mean: LongInt; IniData: PIniFile);
Function GetPrivateProfileBoolean(Appl, Key:String; Default:Boolean; IniData: PIniFile):Boolean;
Procedure SetPrivateProfileBoolean(Appl, Key: String; Mean: Boolean; Mode: TBooleanNotion; IniData: PIniFile);

{ ਬ.
    ⠭ ந   楤 SetProfile...
    ⮫쪮  ६ ⥪饣 ᥠ ࠡ  ணࠬ.
      ⠭ ᯮ SaveProfile 
   KillProfile  ࠬ஬ psSave }

Implementation

Uses
  Arc, Objects;

Function GetProfile(PName: String): PIniFile;
Begin
  GetProfile := New(PIniFile, Init(PName));
End;

Procedure LoadProfile;
Begin
  Profile := GetProfile(PName);
End;

Procedure SaveProfile(PName: String);
Begin
  if Not Assigned(Profile) then Exit;
  Profile^.WriteIni(PName);
End;

Procedure KillProfile(Mode: TSaveMode);
Begin
  if Assigned(Profile) then
  Case Mode of
    psNone: Dispose(Profile, TinyDone);
    psSave: Dispose(Profile, Done);
  End;
  Profile := Nil;
End;

Function GetProfileObj(Appl, Key:String): PKeyObj;
Var
  AName, KName: String;

  Function IsApp(Item: PAppObj): Boolean; Far;
  Begin
    IsApp := Pos(AName,
                 UpperCase(Item^.AppName^)) in [1, 3];
  End;

  Function IsKey(Item: PKeyObj): Boolean; Far;
  Var
    T: String;
  Begin
    T := DelSpace(UpperCase(Item^.Key^));
    IsKey := KName = T;
  End;

Var
  A: PAppObj;
  O: PKeyObj;
  i: Byte;
Begin
  if Not Assigned(Profile) then
  Begin
    GetProfileObj := Nil;
    Exit;
  End;
  AName := '[' + UpperCase(Appl) +']';
  A := Profile^.IniData^.FirstThat(@IsApp);
  if A = Nil then
  Begin
    GetProfileObj := Nil;
    Exit;
  End;
  KName := DelSpace(UpperCase(Key));
  O := A^.Keys^.FirstThat(@IsKey);
  if O = Nil then
  Begin
    GetProfileObj := Nil;
    Exit;
  End
  else
    GetProfileObj := O;
End;

Function GetProfileString(Appl, Key, Default:String): String;
Var
  P: PKeyObj;
  S: String;
  i: Byte;
Begin
  P := GetProfileObj(Appl, Key);
  if (P = Nil) or (P^.Value = Nil) then
  Begin
    GetProfileString := Default;
    Exit;
  End;
  S := P^.Value^;
  Dec(S[0], 2);
{  if S = '' then
  Begin
    GetProfileString := Default;
    Exit;
  End;}
  i := 1;
  While i <= Byte(S[0]) do
  Begin
    if (S[i] = ';') then
      if (S[i+1] <> ';') then
      Begin
         S[0] := Char(i-1);
         Break;
      End
      else
      Begin
        Delete(S, i, 1);
        While (S[i] = ';') and (i <= Length(S)) do
           Inc(i);
        Dec(i);
      End;
    Inc(i);
  End;
  S := DelSpace(S);
  GetProfileString := S;
End;

Procedure SetProfileString(Appl, Key, Eval: String);
Var
  A: PAppObj;
  K: PKeyObj;
  S: String;
  P: PString;
  i: Byte;
  Switch: Boolean;
  AName: String;

  Function IsApp(Item: PAppObj): Boolean; Far;
  Begin
    IsApp := Pos(AName,
                 UpperCase(Item^.AppName^)) in [1, 3];
  End;

  Function LastEoln(Item: PKeyObj): Boolean; Far;
  Begin
    LastEoln := Item^.Key^ <> #13#10;
  End;

Begin
  if Not Assigned(Profile) then Exit;
  K := GetProfileObj(Appl, Key);
  if Assigned(K) and Assigned(K^.Value) then
  Begin
    S := K^.Value^;
    Switch := True;
    For i := 1 to Byte(S[0]) do
    if (S[i] = ';') And ( (S[i+1] <> ';') or (S[i-1] <> ';')) then
    Begin
       Switch := False;
       S := Copy(S, i, Byte(S[0]));
    End;
    if Switch then
       S := #13#10;
    K^.Value^ := Eval + S
  End
  else
  Begin
    AName := '[' + UpperCase(Appl) + ']';
    A := Profile^.IniData^.FirstThat(@IsApp);
    if Assigned(A) then
    Begin
       P := NewStr(Key + '=' + Eval + #13#10);
       K := A^.Keys^.LastThat(@LastEoln);
       if K = Nil then
          A^.Keys^.Insert(New(PKeyObj, Init(P)))
       else
          A^.Keys^.AtInsert(A^.Keys^.IndexOf(K) + 1, New(PKeyObj, Init(P)));
    End
    else
       Profile^.IniData^.Insert(New(PAppObj, InnerInit(Appl, Key, Eval)));
  End;
End;

Function GetProfileBoolean(Appl, Key:String; Default:Boolean): Boolean;
Const
  BoolValue: Array[1..10] of String[3] =
  ('1', '0', '', '', 'YES', 'NO', 'TRU', 'FAl', 'ON', 'OFF');
Var
 S: String;
 i: 1..10;
Begin
  S := DelSpace(UpperCase(GetProfileString(Appl, Key, '')));
  if S = '' then
  Begin
     GetProfileBoolean := Default;
     Exit;
  End
  else
     For i := 1 to 10 do
     if S = BoolValue[i] then Break;
  GetProfileBoolean := Odd(i);
End;

Procedure SetProfileBoolean(Appl, Key: String;
                            Mean: Boolean; Mode: TBooleanNotion);
Const
  BoolValue: Array[TBooleanNotion, Boolean] of String[5] =
  (('1', '0'), ('a', ''), ('Yes', 'No'),
   ('True', 'False'), ('On', 'Off'));
Begin
  SetProfileString(Appl, Key, BoolValue[Mode, Not Mean]);
End;

Function GetProfileInt(Appl, Key: String; Default:LongInt): LongInt;
Var
  S: String;
  R: LongInt;
  C: Integer;
Begin
  S := GetProfileString(Appl, Key, '');
  if S = '' then
     GetProfileInt := Default
  else
  Begin
     S := DelTrash(S);
     Val(S, R, C);
     if C <> 0 then
        GetProfileInt := Default
     else
        GetProfileInt := R
  End;
End;

Procedure SetProfileInt(Appl, Key: String; Mean: LongInt);
Var
  S: String;
Begin
  Str(Mean:0, S);
  SetProfileString(Appl, Key, S);
End;

Procedure NewProfile(PName: String; HeadMessage: PNoSortedStringCollection);
Begin
  Profile := New(PIniFile, TinyInit(PName, HeadMessage));
End;

Procedure NewProfileDefault(PName: String);
Const
   Header: Array[1..5] of String[80] =
   ('; ',
    '; Initialization file for ... <- Set your application here'#13#10,
    '; Copyright (C) ...'#13#10,
    '; All rights reserved. Thank for using V Kulimov''s Ini.file Services'#13#10,
    ';'#13#10 );
Var
  C: PNoSortedStringCollection;
  i: Byte;
Begin
  New(C, Init(5, 1));
  C^.Insert(NewStr(Header[1] + UpperCase(PName) + #13#10));
  For i := 2 to 5 do
    C^.Insert(NewStr(Header[i]));
  NewProfile(PName, C);
End;

Function GetPrivateProfileString(Appl, Key, Default: String; IniData: PIniFile): String;
Var
  P: PIniFile;
Begin
  P := Profile;
  Profile := IniData;
  GetPrivateProfileString := GetProfileString(Appl, Key, Default);
  Profile := P;
End;

Procedure SetPrivateProfileString(Appl, Key, Eval: String; IniData: PIniFile);
Var
  P: PIniFile;
Begin
  P := Profile;
  Profile := IniData;
  SetProfileString(Appl, Key, Eval);
  Profile := P;
End;

Function GetPrivateProfileInt(Appl, Key:String; Default:LongInt; IniData: PIniFile): LongInt;
Var
  P: PIniFile;
Begin
  P := Profile;
  Profile := IniData;
  GetPrivateProfileInt := GetProfileInt(Appl, Key, Default);
  Profile := P;
End;


Procedure SetPrivateProfileInt(Appl, Key: String; Mean: LongInt; IniData: PIniFile);
Var
  P: PIniFile;
Begin
  P := Profile;
  Profile := IniData;
  SetProfileInt(Appl, Key, Mean);
  Profile := P;
End;

Function GetPrivateProfileBoolean(Appl, Key:String; Default:Boolean; IniData: PIniFile):Boolean;
Var
  P: PIniFile;
Begin
  P := Profile;
  Profile := IniData;
  GetPrivateProfileBoolean := GetProfileBoolean(Appl, Key, Default);
  Profile := P;
End;

Procedure SetPrivateProfileBoolean(Appl, Key: String; Mean: Boolean; Mode: TBooleanNotion; IniData: PIniFile);
Var
  P: PIniFile;
Begin
  P := Profile;
  Profile := IniData;
  SetProfileBoolean(Appl, Key, Mean, Mode);
  Profile := P;
End;

Procedure KillPrivateProfile(Mode: TSaveMode; IniData: PIniFile);
Var
  P: PIniFile;
Begin
  P := Profile;
  Profile := IniData;
  KillProfile(Mode);
  Profile := P;
End;

Procedure SavePrivateProfile(PName: String; IniData: PIniFile);
Var
  P: PIniFile;
Begin
  P := Profile;
  Profile := IniData;
  SaveProfile(PName);
  Profile := P;
End;


End.