Unit
   Tools;

{$O+,V-}

{********************************************************************}
{                                                                    }
{ Useful objects, procedures and functions.                          }
{ Copyright (C) V Kulimov, 1994-95 year.                             }
{ Portions Copyright (c) Esvinsky Branch-office & Central Office     }
{ Joint-stock Commercial Bank "Komibank", 1994-95.                   }
{                                                                    }
{********************************************************************}

Interface

Uses
   StdDlg, Dos, Dialogs, Drivers, Views, Objects, Validate;

Type
  TBuffer = Array[0..1024] of Char;
  TDateStr = String[10];

  {*************
     TListBox,     -
      饫箪    ⨥ Enter 뤠 
    । ListBox'y  .
    .
    ' ᮧ Init([standart parameters], cmOk) - ⮣   饫箪
       ⨥ Enter ,   ⨬ ListBox'
      cmOk    ࠡ  ᢮ HandleEvent'e.
    ⢥    ࠡ  ᠬ ListBox - ᫥ 
    TCommandLB.
  ***************}
  PCommandLB = ^TCommandLB;
  TCommandLB = Object(TListBox)
    xCommand: Word;
    Constructor Init(var Bounds: TRect; ANumCols: Word;
                     AScrollBar:PScrollBar; C: Word);
    Procedure HandleEvent(var Event: TEvent); Virtual;
    Procedure SelectItem(Item: Integer); Virtual;
  End;

  PDateInputLine = ^TDateInputLine;
  TDateInputLine = Object(TInputLine)
    Constructor Init(var Bounds: TRect; AMaxLen: Integer);
  End;

  {**************
    Validator ("஢﫪")   ⨯ .
    楤 Error 뤠 MessageBox: "訡   "
    isValid ஢ :
      - ଠ //  ⮡  뫮 32- ᥫ  ..
  *************}
  PDateValidator = ^TDateValidator;
  TDateValidator = Object(TPXPictureValidator)
     Constructor NewInit;
     Procedure Error; Virtual;
     Function isValid(Const S: String): Boolean; Virtual;
  End;

  {*************
      PString'   ⮩ 樨
      浪 㯫,   ஢  䠢
  ***************}
  PNoSortedStringCollection =  ^TNoSortedStringCollection;
  TNoSortedStringCollection = Object(TStringCollection)
    Function Compare(Key1, Key2: Pointer): Integer; virtual;
  End;

  PChangesDirListBox = ^TChangesDirListBox;
  TChangesDirListBox = Object(TDirListBox)
    Procedure SetState(AState: Word; Enable: Boolean); Virtual;
    Procedure HandleEvent(var Event: TEvent); Virtual;
  End;

  PTextStream = ^TTextStream; { ' ᭮  祣.
                                ࠭  NTT Mail. Copyright (C) Serge Latkin }
  {  뢠,  ReadStr 頥 ப, 稢 #13#10,
    ࠬ P  WriteStr  稢 #13#10 - Carriage Return +
                                                       go to Start of Line }
  TTextStream = Object(TBufStream)
    Procedure WriteStr(P: PString);
    Function  ReadStr: PString;
  End;

  {**************
     ।饣 ',  ᫨  ࠡ⠥  String',  
     㪠⥫ﬨ  ,   ' 㤮.   #13#10 
    ⠥  ᨫ.
  *****************}
  PLogFile = ^TLogFile;
  TLogFile = Object(TTextStream)
    Procedure WriteTo(Const S: String); Virtual;
    Function ReadFrom: String;
  End;

  { 뤠  ⨥ Enter SelectNext(False).
    ᫨  ⮡ ଠ쭮 ࠡ⠫ 
    ⠢ OKButton. }
  PKeyEnterDialog = ^TKeyEnterDialog;
  TKeyEnterDialog = Object(TDialog)
    CancelButton,
    OKButton: PButton;
    Procedure HandleEvent(var Event: TEvent); Virtual;
  End;

  PBrowseIL = ^TBrowseIL;
  TBrowseIL = Object(TInputLine)
    OldData: PString;
    Procedure HandleEvent(var Event: TEvent); Virtual;
    Destructor Done; Virtual;
  End;

Const
  { Collection Status Const }
  csOk         = $0000;
  csIndexError = $0001;
  csOverflow   = $0002;
  csLowMemory  = $0003;

  { Collection Error Const }
  coLowMemory  = 9; { Generate Runtime error 202 at default }

Type
  PErrorCollection = ^TErrorCollection;
  TErrorCollection = Object(TCollection)
    Status: Integer;
    Procedure Error(Code, Info: Integer); Virtual;
    Procedure Insert(Item: Pointer); Virtual;
  End;

Type
  SymbolSet = Set of Char;

Function CheckInLousy(S: String; Symb: SymbolSet): String;
{ ஢ઠ  訢 -  S ⠢ ⮫쪮 ᨬ  Symb }
Procedure ShowStatusBox(Msg: String);
{ 㡨ࠥ 짮⥫ (   ⮫쪮 ணࠬ)
    Message' }
Procedure KillStatusBox; {   }
Procedure ShowMessage(M: String); { 饭  ப  }
Procedure KillMessage; {   }
Function  CopyFile(SourceName, TargetName: String): LongInt;
{  zip.pas  㭪  ⥬  ,
    ⮬ ਬ ஦.
}
Function  Exist(FName: String): Boolean;
Function  PrintStatus: Byte;
{ ਭ ⮢ - 頥 144,  ⠫쭮 - PRINTER NOT READY.
   - 㦭  ⠭ ⮢ ਭ.  㬠.}

Procedure Disposes(Var O: PObject);
{ 㦠 '  ᠭ. ᫨ 맢 Dispose  Nil, 
   ᭥ -  ⮩ 楤  ஢ઠ.  ०  
  ⮣  ࠬ PObject -  楤 㦠  ᫥
   PObject - ணࠬ ᠬ ।  Destructor 맢 - 
   !! }
Procedure DisposesStr(P: PString);
Function  StrSum(Inp: String):String;
{  ᨬ쭮 ப 頥  ய }
Function  StrDate(D: String): String;
{    2000 .  Century  .ini-file}
Function  NowDate: String; {譨 }
Function  NowTime: String;
Function  NowFullDate: String;
Procedure BreakStr(Var S1, S2, S3: String; Len: Byte);
{  㪠.
  ᫨    ப,   㦭   㧪 ਭ 
  뢥  㧥쪮   ਫ筮 ,  ᯮ .
  砫:
    S1 - ப  ,
     S2,S3 == ''. Len -  ࠧ.
    ஡.
}
Function  BreakSum(R: String; Symb:Char): String;
{  Symb == ' 
   1354304958.88 ᤥ 1'354'304'958.88 }
Function  GetCount(Pos,Count: Byte; Msg: String): Byte;
{  騩 ᫮  1  Count
   ⢠ ஢   }
Function  FormatPrn(S:String): String;
{ See below text on this function }
Function  FormatDate(S:String): String;
{ ॢ    //  []/[]/
  1/3/94 --> 01/03/1994 }
Function NormalDBFDate(S: String): String;
Function  DelTrash(S: String): String; { See Below }
Procedure ReadDir(X,Y: Word; Var Old : String; Var KExit : Byte);
{    - .  }
Procedure StrLow( var S: String );
Function LowerCase(s:string): String;
Procedure DeleteFile(var filename: PathStr );
{ There next functions tear off
  from Borland Pascal Turbo Vision StdDlg Units }
function DriveValid(Drive: Char): Boolean;
function PathValid(var Path: PathStr): Boolean;
function ValidFileName(var FileName: PathStr): Boolean;
function GetCurDir: DirStr;
function IsWild(const S: String): Boolean;
function IsDir(const S: String): Boolean;
Function  DelSpace(Source: String): String;
{  騥   ஡  Source }
Function GetRandomName(Path, Ext: String): String;
{ 頥 ந쭮  䠩  
  Path + ந쭮  + . + Ext -  ४ਨ Path 
  䠩   -  ⮣  㭪 }
Function GetDateDialog(Msg, inString: String): String;
Procedure ChangeMakeDir(S: PathStr);
Function LongCopy(Source: TBuffer; Pos: Word; Count: Byte): String;
Function CenterStr(S: String; Len: Byte): String;
Function JustifyRight(S: String; Len: Byte): String;
Function JustifyLeft(S: String; Len: Byte): String;
Function NormalDate(D: TDateStr): TDateStr;

Implementation

Uses
   Crt, App, MsgBox, Arc, StdConst, IniServ, Memory;

type
  PMessage = ^TMessage;
  TMessage = object(TView)
    S : String;
    constructor Init(Mess: String);
    procedure Draw; virtual;
  end;

Const
  MView: PMessage = Nil;
  StatusBox  : PDialog = nil;

{  TMessage Object  }

Constructor TMessage.Init(Mess: String);
Var
   R: TRect;
begin
  R.Assign(0, 24, 72, 25);
  inherited Init(R);
  S := ' ' + Mess;
end;

procedure TMessage.Draw;
var
  B: TDrawBuffer;
  C: Byte;
begin
  C := GetColor(2);
  MoveChar(B, ' ', C, Size.X);
  MoveStr(B, S, C);
  WriteLine(0, 0, Size.X, 1, B);
end;

Procedure ShowMessage;
Begin
  if Not Assigned(MView) then
  Begin
     MView := New(PMessage, Init(M));
     Application^.Insert(MView);
  End;
End;

Procedure KillMessage;
Begin
  Disposes(PObject(MView));
End;

Function TNoSortedStringCollection.Compare(Key1, Key2: Pointer): Integer;
Begin
  Compare := -1;
End;

Function PrintStatus: Byte; Assembler;
asm
    MOV   AH,2
    MOV   DX,0
    INT   17H
    MOV   AL,AH
End;

Procedure ShowStatusBox(Msg: String);
var
  R: TRect;
begin
  if StatusBox <> nil then exit;
  R.Assign(0,0,40,5);
  R.Move(20,8);
  StatusBox := New(PDialog, Init(R, ''));
  with StatusBox^ do
  begin
    Options := Options and (not ofBuffered);
    Flags := Flags and (not wfClose) and (not wfMove);
    R.Assign(2,2,38,3);
    Insert(New(PParamText, Init(R, ^C' ' + Msg, 1)));
  end;
  Desktop^.Insert(StatusBox);
end;

procedure KillStatusBox;
begin
  if StatusBox <> nil then
  begin
    Dispose(StatusBox, Done);
    StatusBox := nil;
  end;
end;

{ TCommandLB Object }
Constructor TCommandLB.Init;
Begin
  Inherited Init(Bounds, ANumCols, AScrollBar);
  xCommand := C;
End;

procedure TCommandLB.SelectItem(Item: Integer);
var
  E: TEvent;
begin
  inherited SelectItem(Item);
  with E do
  begin
    What := evCommand;
    Command := xCommand;
    InfoPtr := nil;
  end;
  PutEvent(E);
end;

Procedure TCommandLB.HandleEvent;
Begin
  if Event.What = evKeyDown then
  if Event.KeyCode = kbEnter then
     Message(@Self, evCommand, xCommand, Nil);
  Inherited HandleEvent(Event);
End;

Function CopyFile(SourceName, TargetName: String): LongInt;
{ Function return count of copying bytes,
  or 0 if copying not successful. }
Var
   Source, Target: PBufStream;
Begin
     CopyFile := 0;
     Source := New(PBufStream, Init(SourceName, stOpenRead, 2048));
     if Source^.Status <> stOk then
     Begin
        Dispose(Source, Done);
        Exit
     end;

     Target := New(PBufStream, Init(TargetName, stCreate, 2048));
     Target^.CopyFrom(Source^, Source^.GetSize);

     if Source^.GetSize <> Target^.GetSize then
        CopyFile := 0
     else
        CopyFile := Target^.GetSize;

     Dispose(Source, Done);
     Dispose(Target, Done);
End;

Function Exist(FName: String): Boolean;
Var
  F: PDosStream;
Begin
  F := New(PDosStream, Init(FName, stOpenRead));
  Exist := F^.Status = stOk;
  Dispose(F, Done);
End;

Procedure Disposes(Var O: PObject);
Begin
  if Assigned(O) then
  Begin
     Dispose(O, Done);
     O := Nil;
  End;
End;

Constructor TDateInputLine.Init;
Begin
  Inherited Init(Bounds, AMaxLen);
  SetValidator(New(PDateValidator,
                      Init('{#[#]}/{#[#]}/[####]', True)));

End;

{  TDateValidator Object  }
Constructor TDateValidator.NewInit;
Begin
  Inherited Init('{#[#]}/{#[#]}/[##]', True);
End;

Procedure TDateValidator.Error;
Begin
  MessageBox(^C'訡  p !', Nil, mfError + mfOKButton);
end;

Function TDateValidator.isValid(Const S: String): Boolean;
Var
  P: String[2];
  i: Byte;
  A: String;
Begin
  A := S;
  isValid := False;
  if A = '' then Exit;
  isValid := True;
  P := Copy(A, 1, Pos('/',A) - 1);
  Delete(A, 1, Pos('/', A));
  While Length(P) < 2 do
    P := '0' + P;
  if (P < '01') or (P > '31') then
  Begin
    isValid := False;
    Exit;
  End;
  P := Copy(A, 1, Pos('/',A) - 1);
  Delete(A, 1, Pos('/', A));
  While Length(P) < 2 do
    P := '0' + P;
  if (P < '01') or (P > '12') then
  Begin
    isValid := False;
    Exit;
  End;
End;

Function StrSum(Inp: String):String;
Const
  CifMan: Array[1..19] of String[12] =
       ('', '', '', '', '',
        '', 'ᥬ', 'ᥬ', '', '',
        '', '', 'ਭ',
        'ୠ', '⭠a', '⭠',
        'ᥬ', 'ᥬ', '⭠');
  DecCif: Array[2..9] of String[11] =
        ('', 'ਤ', 'ப', '줥',
         '줥', 'ᥬ줥', 'ᥬ줥', 'ﭮ');
  StoCif: Array[1..9] of String[9] =
        ('', '', '', '', '',
         '', 'ᥬ', 'ᥬ', '');

Var
  S,P,Cop       : String;
  Out           : Boolean;
  Ch,Chh        : Char;
  Code, C       : Integer;
  i,j,k: 1..4;  { 1 -  1000;
              2 -  .;
              3 -  .;
              4 - ᫥ . }
Begin
  S := Inp;
  While S[1] = '0' do
     Delete(S, 1, 1);

  if Pos('.',S) <> 0 then
  Begin
    Cop := Copy(S, Pos('.', S)+1, 2);
    Delete(S, Pos('.', S), 10);
  End
  else
     Cop := '';

  While Length(Cop) <> 2 do
     Cop := '0' + Cop;

  Cop := Cop + ' .';


  i := 1;
  Out := True;
  While Out do
  Begin
    if Length(S) > 3 then
    Begin
       P := Copy(S, Length(S) - 2, 3);
       Delete(S, Length(S) - 2, 3);
    End
    else
    Begin
      P := S;
      Out := False;
    End;

    Ch := Char(P[Length(P)]);
    Chh := Char(P[Length(P)-1]);

    Case i of
      1: if Chh = '1' then
            Cop := '㡫 ' + Cop
         else
         Begin
           Case Ch of
             #0 : Begin
                    StrSum := '00 㡫 ' + Cop;
                    Exit;
                  End;
             '1': Cop := '㡫 ' + Cop;
             '2'..'4': Cop := '㡫 ' + Cop;
           else
             Cop := '㡫 ' + Cop;
           End;
         End;
      2: if P <> '000' then
         if Chh = '1' then
           Cop := ' ' + Cop
         else
           Case Ch of
             '1': Cop := ' ' + Cop;
             '2'..'4': Cop := ' ' + Cop;
           else
             Cop := ' ' + Cop;
           End;
      3: if P <> '000' then
         if Chh = '1' then
            Cop := ' ' + Cop
         else
         Case Ch of
           '1': Cop := ' ' + Cop;
           '2'..'4': Cop := ' ' + Cop;
         else
           Cop := ' ' + Cop;
         End;
      4: if Chh = '1' then
            Cop := 'म ' + Cop
         else
         Case Ch of
           '1': Cop := ' ' + Cop;
           '2'..'4': Cop := 'ठ ' + Cop;
           else
             Cop := 'म ' + Cop;
         End;
    End;

    k := 1;
    While (P[1] = '0') and (P <> '') do
      Delete(P, 1, 1);

    While True do
    Begin
      if P = '' then
         Break;
      j := Length(P);
{      Dec(P[0]); }
      Ch := Char(P[j]);
      Val(Ch, C, Code);

      Case k of
        1: if Chh = '1' then
              Cop := CifMan[10+C] + ' ' + Cop
           else
           if C <> 0 then
           Begin
             if i = 2 then
                Case Ch of
                   '1': Cop := ' ' + Cop;
                   '2': Cop := ' ' + Cop;
                else
                   Cop := CifMan[C] + ' ' + Cop;
                End
             else
                Cop := CifMan[C] + ' ' + Cop;
             Chh := Ch;
           End;
        2: if (C <> 0) and (C <> 1) then
              Cop := DecCif[C] + ' ' + Cop;
        3: Cop := StoCif[C] + ' ' + Cop;
      End;
      Inc(k);
      Dec(P[0]);
    End;
    Inc(i);
  End;
  P := Cop;
  While Pos('  ', P) <> 0 do
    Delete(P, Pos('  ', P), 1);
  Cop := P;
  Cop[1] := UpperChar(Cop[1]);
  StrSum := Cop;
End;

Function StrDate(D:String): String;
Const
     Month : Array[1..12] Of String[9] =
      ('ﭢ ','䥢ࠫ ',' ','५ ',' ',' ',
       ' ',' ','ᥭ ',' ',' ',' ');
Var
   S, Day, Mon, Year: String;
   k,i: Byte;
   Code: Integer;
Begin
   if (Length(D) < 6) or (Pos('/', D) = 0)  then
   Begin
     StrDate := '訡  ';
     Exit;
   End;
   i := 1;
   Day := '';
   Mon := '';
   Year := '';
   While D[i] <> '/' do
   Begin
     Day := Day + D[i];
     Inc(i);
   End;
   Inc(i);
   While D[i] <> '/' do
   Begin
     Mon := Mon + D[i];
     Inc(i);
   End;
   Inc(i);
   While i < Length(D) + 1 do
   Begin
     Year := Year + D[i];
     Inc(i);
   End;
   Val(Mon,k,Code);
   if k in [1..12] then
     S := Concat(Day,' ', Month[k], Year,' .')
   else
     S := '訡  ';
   While Length(S) < 19 do
     S := S + ' ';
   StrDate := S;
End;

Procedure BreakStr(Var S1, S2, S3: String; Len: Byte);
Var
  i, j : Byte;
  P    : String;
  Out  : Boolean;
  S    : Array[1..4] of String;
Begin
  If Length(S1) < Len then Exit;
  P := '';
  S[1] := S1;
  S[2] := S2;
  S[3] := S3;
  Out := True;
  j := 1;
  While Out do
  Begin
    While True do
    Begin
      i := Pos(' ', S[j]);
      if Length(P) + i > Len then Break;
      if i = 0 then
      Begin
        if Length(P) + Length(S[j]) > Len then Break;
        P := P + S[j];
        S[j] := '';
        Break;
      End;
      P := P + Copy(S[j], 1, i);
      Delete(S[j], 1, i);
    End;
    S[j+1] := S[j];
    S[j] := P;
    P := '';
    if j = 3 then Break;
    Inc(j);
  End;
  S1 := S[1];
  S2 := S[2];
  S3 := S[3];
End;

Function NowDate: String;
var
  y, m, d, dow : Word;
  S,P: String;
begin
  GetDate(y,m,d,dow);
  Str(D:0,P);
  S := P + '/';
  Str(m:0,P);
  S := S + P + '/';
  Str(Y:0, P);
  NowDate := S + Copy(P,3,2);
end;

Function NowFullDate: String;
var
  y, m, d, dow : Word;
  S,P: String;
begin
  GetDate(y,m,d,dow);
  Str(D:0,P);
  S := P + '/';
  Str(m:0,P);
  S := S + P + '/';
  Str(Y:0, P);
  NowfullDate := S + P;
end;

Function GetCount(Pos, Count: Byte; Msg: String) : Byte;
Type
  DataRec = Record
    C: PStringCollection;
    F: Integer;
  End;
Var
  D: PDialog;
  R: TRect;
  Control,C : PView;
  Q: DataRec;
  B,i: Byte;
  S: String;
begin
  if Length(Msg) > 50 then
     B := 54
  else
     B := Length(Msg) + 10;

  R.Assign(0, 0, B, 10);

  New(D, Init(R, '⢮ ஢'));

  With D^ do
  Begin
    Options := Options or ofCentered;
    HelpCtx := hcGetCount;

    R.Assign(22, 1, 23, 6);
    C := New(PScrollBar, Init(R));
    Insert(C);

    R.Assign(3, 1, 15, 6);

    Control := New(PListBox, Init(R, 1, PScrollBar(C)));

    Q.C := New(PNoSortedStringCollection, Init(10, 2));
    For i := 1 to Count do
    Begin
      Str(i, S);
      S := CenterStr(DelTrash(S), 10);
      Q.C^.Insert(NewStr(S));
    End;

    Control^.Options := Control^.Options or ofCenterX;
    Q.F := Pos - 1;
    Insert(Control);

    R.Assign(3, 7, 13, 9);
    Control := New(PButton, Init(R, 'O~k~', cmOK, bfDefault));
    D^.Insert(Control);

    R.Assign(15, 7, 25, 9);
    Control := New(PButton, Init(R, '⬥', cmCancel, bfNormal));
    D^.Insert(Control);

    D^.SelectNext(False);
  End;
  if Application^.ExecuteDialog(D, @Q) = cmOk then
     GetCount := Q.F + 1
  else
     GetCount := 0;
  Dispose(Q.C, Done);
End;

{  TTextStream Object Read and Write Methods  }

Function  TTextStream.ReadStr: PString;
var
  S: String[255];
  i: Byte;
begin
  for i := 1 to 255 do begin
    Read(S[i], 1);
    if S[i] = #10 then
       Break;
    if (Status <> stOk) then
      if i <> 1 then
        Break
      else
      Begin
        ReadStr := Nil;
        Exit;
      End;
  end;
  S[0] := Char(i);
  ReadStr := NewStr(S);
end;

Procedure TTextStream.WriteStr(P: PString);
begin
  Write(P^[1], Byte(P^[0]));
end;

{ TLogFile Write & Read Methods }

Procedure TLogFile.WriteTo;
Var
  P: PString;
Begin
  P := NewStr(S);
  WriteStr(P);
  DisposesStr(P);
  Flush;
End;

Function TLogFile.ReadFrom: String;
Var
  P: PString;
Begin
  P := ReadStr;
  if Assigned(P) then
     ReadFrom := P^
  else
     ReadFrom := '';
  DisposesStr(P);
End;

Function BreakSum(R: String; Symb:Char): String;
Var
  i, j: Byte;
  P, K, S: String;
Begin
  S := DelTrash(R);
  P := '';
  j := 1;
  For i := Length(S) downto 1 do
    P := P + S[i];
  i := 1;
  K := '';
  if Pos('.', P) <> 0 then
  Repeat
    K := K + P[i];
    Inc(i);
  Until P[i-1] = '.';

  j := 0;

  While i <= Length(P) do
  Begin
    if j = 3 then
    Begin
      K := K + Symb;
      j := 0;
    End;
    K := K + P[i];
    Inc(j);
    Inc(i);
  End;
  j := 1;
  P := '';
  For i := Length(K) downto 1 do
    P := P + K[i];
  if Pos('.', P) = 0 then
     P := P + '.00';
  BreakSum := P;
End;

Function  FormatPrn(S:String): String;
{
  Special symbols in FormatPrn function:
    ^D^ - double impact
    ^CD^ - cancel double impact
    ^P^ -
    ^CP^ -
    ^DR^ -
    ^BELL^
}
Const
  SymbCount = 7;
  SpecialChars: Array[1..SymbCount] of String[6] =
  ('^D^', '^CD^', '^P^', '^CP^', '^DR^', '^BELL^', '^M');
  OutputChars:  Array[1..SymbCount] of String[3] =
  (#$1B#$45,#$1B#$46,#$0F,#$12,#$1B#$78#$0,#7,#13#10);
Var
  k,i: Byte;
  P: String;
Begin
  P := S;
  For i := 1 to SymbCount do
  While Pos(SpecialChars[i], P) <> 0 do
  Begin
    k := Pos(SpecialChars[i], P);
    Delete(P, k, Length(SpecialChars[i]));
    Insert(OutputChars[i], P, k);
  End;
  FormatPrn := P;
End;

Function FormatDate(S: String): String;
Var
  P: String[2];
  K: String[10];
  i: Byte;
  A: String;
Begin
  K := '';
  A := S;
  if A = '' then
  Begin
     FormatDate := '';
     Exit;
  End;
  P := Copy(A, 1, Pos('/',A) - 1);
  Delete(A, 1, Pos('/', A));
  While Length(P) < 2 do
    P := '0' + P;
  K := P + '/';
  P := Copy(A, 1, Pos('/',A) - 1);
  Delete(A, 1, Pos('/', A));
  While Length(P) < 2 do
    P := '0' + P;
  While Length(A) < 2 do
     A := '0' + A;
  if Length(A) = 2 then
     A := GetProfileString('System', 'Century', '19') + A;
  K := K + P + '/' + A;
  FormatDate := K;
End;

Function DelTrash(S: String): String;
Var
  i: Byte;
  P: String;
Begin
  P := '';
  For i := 1 to Length(S) do
  if Char(S[i]) in ['0'..'9', '.'] then
     P := P + S[i];
  DelTrash := P
End;

Procedure ReadDir(X,Y: Word; Var Old : String; Var KExit : Byte);
Var
  Wrem       : String  ;
  i,Key      : Integer ;
  Out        : Boolean ;
  Ch         : Char    ;
  Pos,
  Xt,Yt      : Byte    ;

Begin
  Wrem := Old;
  GoToXY(X,Y);
  Write(Wrem);
  GoToXY(X,Y);
  Pos := 0;
  Out := False;
  Repeat
    Ch := ReadKey;
    if Ch = #0 then Ch := ReadKey
    else
    if Ch in [ '0'..'9', 'A'..'z', ':', '\'] then
    if X+Pos<80 then
    Begin
      Write(Ch);
      if Pos = Length(Wrem) then
        Wrem := Wrem + Ch
      else
        Wrem[Pos+1] := Ch;
      Inc(Pos)
    End;

    Key := Ord(Ch);

    Case Key of
      Return, Esc: Begin
                     Out := True;
                     if Key = Esc then
                       Kexit := 1
                     else
                       KExit := 0;
                   End;
      Back_Space: if Pos > 0 then
                  Begin
                     Delete(Wrem, Pos, 1);
                     Dec(Pos);
                     GotoXY(X, Y);
                     Write(Wrem); ClrEol;
                     GotoXY(X+Pos, Y);
                  end;
      Del : if Pos < Length(Wrem) then
            Begin
                Delete(Wrem, Pos+1, 1);
                GotoXY(X, Y);
                Write(Wrem); ClrEol;
                GotoXY(X+Pos, Y);
              end;
      Left: if Pos > 0 then
            Begin
              Dec(Pos);
              GotoXY(X+Pos, Y);
            End;
      KeyEnd: Begin
                Pos := Length(Wrem);
                GotoXY(X+Pos, Y);
              End;
      Right: if (Pos < Length(Wrem)) and (X+Pos<80) then
             Begin
              Inc(Pos);
              GotoXY(X+Pos, Y);
            End;
    End;
  Until Out;
  if KExit = 0 then
     Old := Wrem;
  GotoXY(X, Y); ClrEol;
  Write(Old);
End;

procedure StrLow( var S: String ); assembler;
asm
        les     di, S
        mov     cl, es:[di]
        xor     ch, ch
        mov     al, 20h
@@1:    inc     di
        mov     ah, es:[di]
        cmp     ah, 'A'
        jb      @@3
        cmp     ah, 'Z'
        ja      @@3
        or      es:[di],al
@@3:
        loop    @@1
end;

procedure DeleteFile(var filename: PathStr );
Begin
  if FileName[Length(FileName)] <> #0 then
     FileName := FileName + #0;
  asm
       push    ds
       lds     dx, filename
       inc     dx
       mov     ah, 41h
       int     21h
       pop     ds
  End;
end;

function DriveValid(Drive: Char): Boolean; assembler;
asm
        MOV     AH,19H          { Save the current drive in BL }
        INT     21H
        MOV     BL,AL
        MOV     DL,Drive        { Select the given drive }
        SUB     DL,'A'
        MOV     AH,0EH
        INT     21H
        MOV     AH,19H          { Retrieve what DOS thinks is current }
        INT     21H
        MOV     CX,0            { Assume false }
        CMP     AL,DL           { Is the current drive the given drive? }
        JNE     @@1
        MOV     CX,1            { It is, so the drive is valid }
        MOV     DL,BL           { Restore the old drive }
        MOV     AH,0EH
        INT     21H
@@1:    XCHG    AX,CX           { Put the return value into AX }
end;

function PathValid(var Path: PathStr): Boolean;
var
  ExpPath: PathStr;
  F: File;
  SR: SearchRec;
begin
  ExpPath := FExpand(Path);
  if Length(ExpPath) <= 3 then PathValid := DriveValid(ExpPath[1])
  else
  begin
    if ExpPath[Length(ExpPath)] = '\' then Dec(ExpPath[0]);
    FindFirst(ExpPath, Directory, SR);
    PathValid := (DosError = 0) and (SR.Attr and Directory <> 0);
  end;
end;

function ValidFileName(var FileName: PathStr): Boolean;
const
  IllegalChars = ';,=+<>|"[] \';
var
  Dir: DirStr;
  Name: NameStr;
  Ext: ExtStr;

{ Contains returns true if S1 contains any characters in S2 }
function Contains(S1, S2: String): Boolean; near; assembler;
asm
        PUSH    DS
        CLD
        LDS     SI,S1
        LES     DI,S2
        MOV     DX,DI
        XOR     AH,AH
        LODSB
        MOV     BX,AX
        OR      BX,BX
        JZ      @@2
        MOV     AL,ES:[DI]
        XCHG    AX,CX
@@1:    PUSH    CX
        MOV     DI,DX
        LODSB
        REPNE   SCASB
        POP     CX
        JE      @@3
        DEC     BX
        JNZ     @@1
@@2:    XOR     AL,AL
        JMP     @@4
@@3:    MOV     AL,1
@@4:    POP     DS
end;

begin
  ValidFileName := True;
  FSplit(FileName, Dir, Name, Ext);
  if not ((Dir = '') or PathValid(Dir)) or Contains(Name, IllegalChars) or
    Contains(Dir, IllegalChars) then ValidFileName := False;
end;

function GetCurDir: DirStr;
var
  CurDir: DirStr;
begin
  GetDir(0, CurDir);
  if Length(CurDir) > 3 then
  begin
    Inc(CurDir[0]);
    CurDir[Length(CurDir)] := '\';
  end;
  GetCurDir := CurDir;
end;

function IsWild(const S: String): Boolean;
begin
  IsWild := (Pos('?',S) > 0) or (Pos('*',S) > 0);
end;

function IsDir(const S: String): Boolean;
var
  SR: SearchRec;
begin
  FindFirst(S, Directory, SR);
  if DosError = 0 then
    IsDir := SR.Attr and Directory <> 0
  else IsDir := False;
end;

Function DelSpace(Source: String): String;
Var
  S: String;
Begin
  S := Source;
  While (S[1] = ' ') and (S <> '') do
    Delete(S, 1, 1);
  While (S[Byte(S[0])] = ' ') and (S <> '') do
    Dec(S[0]);
  DelSpace := S;
End;

Function LowerCase(s:string): String;
var
  i : Integer;
  C : Char;
begin
  for i := 1 to Length(s) do
    if s[i] in ['A'..'Z'] then
       Inc(s[i], 32)
    else
    Begin
      C := s[i];
      Case C of
        ''..'': Inc(s[i], Ord('') - Ord(''));
        ''..'': Inc(s[i], Ord('') - Ord(''));
      End;
    End;
    LowerCase := s;
end;

Function GetRandomName(Path, Ext: String): String;
Var
  S: String;
  i: byte;
Begin
  Randomize;
  Repeat
    S := '';
    for i := 1 to 8 do
      S := S + Chr(Random(Ord('z') - Ord('a')) + Ord('a'));
  Until Not Exist(Path + S + '.' + Ext);
  GetRandomName := Path + S + '.' + Ext;
End;

Function GetDateDialog(Msg, inString: String): String;
Var
  R: TRect;
  D: PDialog;
  IL: PInputLine;
  S, P: String;
Begin
  R.Assign(0, 0, 60, 7);
  D := New(PDialog, Init(R, ' '));
  With D^ do
  Begin
    if Length(Msg) > 44 then
       Msg[0] := #44;
    Options := Options or ofCentered;
    R.Assign(Byte(Msg[0]) + 3, 2, Byte(Msg[0]) + 15, 3);
    IL := New(PInputLine, Init(R, 10));
    IL^.SetValidator(New(PDateValidator,
                      Init('{#[#]}/{#[#]}/[####]', True)));
    Insert(IL);

    R.Assign(1, 2, Byte(Msg[0]) + 2, 3);
    Insert(New(PLabel, Init(R, Msg, IL)));

    R.Assign(10, 4, 24, 6);
    Insert(New(PButton, Init(R, 'OK', cmOk, bfDefault)));

    R.Move(30, 0);
    Insert(New(PButton, Init(R, 'O⬥', cmCancel, bfNormal)));

    SelectNext(False);
  End;
  S := inString;
  if Application^.ExecuteDialog(D, @S) = cmOk then
     GetDateDialog := S
  else
     GetDateDialog := '';
End;

Procedure ChangeMakeDir(S: PathStr);
Var
  D,P: String;
  i: Byte;
Begin
  GetDir(0, P);
  if P[Byte(P[0])] = '\' then Dec(P[0]);
  if S[Byte(S[0])] = '\' then Dec(S[0]);
  if Pos(':', S) <> 0 then
  Begin
    if Pos(':', S) <> 2 then
    Begin
      WriteLn('Invalid path.');
      Halt(9);
    End;
    D := S[1] + S[2];
    Delete(S, 1, 2);
    if S[1] = '\' then
    begin
      D := D +'\';
      Delete(S, 1, 1);
    End;
    {$I-}
    ChDir(D);
    if IOResult <> 0 then
    Begin
      WriteLn('Invalid or broken drive.');
      Halt(4);
    End;
  End
  else
  Begin
      WriteLn('Drive not specifyed.');
      Halt(6);
  End;

  While S <> '' do
  Begin
     if Pos('\', S) <> 0 then
     Begin
        D := Copy(S, 1, Pos('\', S) - 1);
        Delete(S, 1, Pos('\', S));
     End
     else
     Begin
        D := S;
        S := '';
     End;
     {$I-}
     ChDir(D);
     if IOResult <> 0 then
     Begin
       {$i-}
       MkDir(D);
       if IOResult <> 0 then
       Begin
          WriteLn('Fatal error, I''m sorry...');
          Halt(5);
       End
       else
         ChDir(D);
     End;
  End;
  ChDir(P);
End;

Procedure TChangesDirListBox.SetState(AState: Word; Enable: Boolean);
Begin
  TListBox.SetState(AState, Enable);
End;

Procedure TChangesDirListBox.HandleEvent(var Event: TEvent);
Var
  P: PDirEntry;
  CurDir: DirStr;
Begin
  Case Event.What of
    evKeyDown: Message(@Owner, evCommand, cmChangeDir, Nil);
    evCommand: if Event.What = cmChangeDir then
               begin
                   P := List^.At(Focused);

                   if (P^.Directory^ = Drives^) or
                   DriveValid(P^.Directory^[1]) then
                      CurDir := P^.Directory^
                   else
                      Exit;

                   if (Length(CurDir) > 3) and
                   (CurDir[Length(CurDir)] = '\') then
                      Dec(CurDir[0]);

                   NewDirectory(CurDir);
                   DrawView;
                 end;
    End;
    Inherited HandleEvent(Event);
End;

{  TKeyEnterDialog object  }
Procedure TKeyEnterDialog.HandleEvent;
Begin
  if Event.What = evKeyDown then
  Case Event.KeyCode of
    kbEnter: if (Current <> PView(OKButton)) and
                (Current <> PView(CancelButton)) then
             Begin
               ClearEvent(Event);
               SelectNext(False);
               Exit;
             End;
    kbRight: if Current = PView(OKButton) then
             Begin
               ClearEvent(Event);
               SelectNext(False);
               Exit;
             End;
    kbLeft: if Current = PView(CancelButton) then
            Begin
              ClearEvent(Event);
              SelectNext(True);
              Exit;
            End;
  End;
  Inherited HandleEvent(Event);
End;

Function LongCopy(Source: TBuffer; Pos: Word; Count: Byte): String;
Var
  i: Word;
  E: String;
Begin
  E := '';
  for i := Pos to Pos + Count - 1 do
    E := E + Source[i];
  LongCopy := E;
End;

Function CenterStr(S: String; Len: Byte): String;
Begin
  if Len < Length(S) then
     CenterStr := S
  else
    CenterStr := Space((Len - Length(S)) shr 1) + S;
End;

Function JustifyRight(S: String; Len: Byte): String;
Begin
  JustifyRight := S;
  if Length(S) < Len then
     JustifyRight := Space((Len - Length(S))) + S;
End;

Function JustifyLeft(S: String; Len: Byte): String;
Begin
  JustifyLeft := S;
  if Length(S) < Len then
     JustifyLeft := S + Space((Len - Length(S)));
End;


Procedure TErrorCollection.Error;
Begin
  Case Code of
    coIndexError: Status := csIndexError;
    coOverflow: Status := csOverflow;
    coLowMemory: Status := csLowMemory;
  End;
End;

Procedure TErrorCollection.Insert(Item: Pointer);
Begin
  if LowMemory then
    Error(coLowMemory, 0)
  else
    Inherited Insert(Item);
End;

Procedure DisposesStr;
Begin
  if Assigned(P) then
    DisposeStr(P)
End;

Function CheckInLousy(S: String; Symb: SymbolSet): String;
Var
  i: Byte;
  P: String;
Begin
  P := '';
  For i := 1 to Length(S) do
  if Char(S[i]) in Symb then
     P := P + S[i];
  CheckInLousy := P
End;

Procedure TBrowseIL.HandleEvent(var Event: TEvent);
Begin
  if Event.What = evKeyDown then
  Case Event.KeyCode of
    kbEnter: Begin
                Message(Owner, evBroadCast, cmEditIL, Data);
                ClearEvent(Event)
             End;
    kbEsc: Begin
             Message(Owner, evBroadCast, cmCancelEditIL, OldData);
             ClearEvent(Event);
           End;
  End;
  Inherited HandleEvent(Event);
End;

Destructor TBrowseIL.Done;
Begin
  DisposesStr(OldData);
  Inherited Done;
End;

Function NormalDate(D: TDateStr): TDateStr;
Var
  S: TDateStr;
Begin
  S := FormatDate(D);
  S := CheckInLousy(S, ['0'..'9']);
  Delete(S, 5, 2);
  NormalDate := Copy(S, 5, 2) + Copy(S, 3, 2) + Copy(S, 1, 2);
End;

Function NormalDBFDate(S: String): String;
Begin
  NormalDBFDate := Copy(S, 7, 2) + '/' + Copy(S, 5, 2) + '/' + Copy(S, 1, 4);
End;

Function NowTime: String;
  function LeadingZero(w : Word) : String;
  var
    s : String;
  begin
    Str(w:0,s);
    if Length(s) = 1 then
      s := '0' + s;
    LeadingZero := s;
  end;
var
  h, m, s, hund : Word;
begin
  GetTime(h,m,s,hund);
  NowTime := LeadingZero(h) + ':' + LeadingZero(m) + ':' + LeadingZero(s);
end;

end.

