Unit
  WINIServ;

{ Modified Windows-like ini.file services.
  Copyright (C) V Kulmiov, 1995.
  Portions Copyright (C) Joint-Stock Commercial Bank "Komibank".
  Another Copyrigth Microsoft Copr. 1985-1993 year.
}

Interface

Type
  TBooleanNotion = (bnNumeric, bnYesNo, bnBoolean, bnSwitch);

Function  GetProfileString(Appl, Key, Default:String): String;
Procedure SetProfileString(Appl, Key, Eval: String);
Function  GetProfileBoolean(Appl, Key:String; Default:Boolean): Boolean;
Procedure SetProfileBoolean(Appl, Key: String; Mean: Boolean; Mode: TBooleanNotion);
Function  GetProfileInt(Appl, Key:String; Default:LongInt): LongInt;
Procedure SetProfileInt(Appl, Key: String; Mean: LongInt);
Function  InitProfile(PName: String): Boolean;

Implementation

Uses
  WinProcs, Strings, WinTools;

Const
  ProfileName: Array[0..80] of Char = '';


Procedure SetProfileString(Appl, Key, Eval: String);
Var
  A, K, E: Array[0..80] of Char;
Begin
  StrPCopy(A, Appl);
  StrPCopy(K, Key);
  StrPCopy(E, Eval);
  WritePrivateProfileString(A, K, E, ProfileName);
End;

Function  GetProfileString(Appl, Key, Default:String): String;
Var
  A, K, D, R: Array[0..80] of Char;
Begin
  StrPCopy(A, Appl);
  StrPCopy(K, Key);
  StrPCopy(D, Default);
  GetPrivateProfileString(A, K, D, R, 80, ProfileName);
  getProfileString := StrPas(R);
End;

Function GetProfileBoolean(Appl, Key:String; Default:Boolean): Boolean;
Const
  BoolValue: Array[1..8] of String[3] =
  ('1', '0', 'YES', 'NO', 'TRU', 'FAl', 'ON', 'OFF');
Var
 S: String;
 i: 1..10;
Begin
  S := DelSpace(UpperCase(GetProfileString(Appl, Key, '')));
  if S = '' then
  Begin
     GetProfileBoolean := Default;
     Exit;
  End
  else
     For i := 1 to 10 do
     if S = BoolValue[i] then Break;
  GetProfileBoolean := Odd(i);
End;

Procedure SetProfileBoolean(Appl, Key: String;
                            Mean: Boolean; Mode: TBooleanNotion);
Const
  BoolValue: Array[TBooleanNotion, Boolean] of String[5] =
  (('1', '0'), ('Yes', 'No'),
   ('True', 'False'), ('On', 'Off'));
Begin
  SetProfileString(Appl, Key, BoolValue[Mode, Not Mean]);
End;

Function GetProfileInt(Appl, Key: String; Default:LongInt): LongInt;
Var
  S: String;
  R: LongInt;
  C: Integer;
Begin
  S := GetProfileString(Appl, Key, '');
  if S = '' then
     GetProfileInt := Default
  else
  Begin
     S := DelTrash(S);
     Val(S, R, C);
     if C <> 0 then
        GetProfileInt := Default
     else
        GetProfileInt := R
  End;
End;

Procedure SetProfileInt(Appl, Key: String; Mean: LongInt);
Var
  S: String;
Begin
  Str(Mean:0, S);
  SetProfileString(Appl, Key, S);
End;

Function InitProfile(PName: String): Boolean;
Begin
  InitProfile := Exist(PName);
  StrPCopy(ProfileName, PName);
End;

End.


